class Shape:
  def __init__(self):
    pass    
  def type(self):
    return ''
  
  def draw(self):
    return

  def boundingRect(self):
    return None

  def intersects(self, other):
    return self.boundingRect().overlaps(other.boundingRect())

class Rect(Shape):
  def __init__ (self, x, y, a, b):
    """Costruisce un Rect con lati a e b e top left in x, y"""
    self.a=a
    self.b=b
    self.x=x
    self.y=y
    
  def draw(self):
     print ("Rect: topLeft %d,%d,  %dx%d" % (self.x, self.y , self.a, self.b)) 
  
  def boundingRect(self):
    return Rect(self.x, self.y, self.a, self.b)
    
  def setRect(self, p0_x, p0_y, a, b):
    self.a =  a
    self.b = b
    self.x = p0_x + self.b/2
    self.y = p0_y + self.a/2
  
  def overlaps(self, other):
    return (self.x <= other.x and self.y <= other.y and self.x + self.a > other.x and self.y + self.b > other.y) \
	 or (other.x <= self.x and other.y <= self.y and other.x + other.a > self.x and other.y + other.b > self.y)
    

  def type(self):
    return 'r'

class Square(Rect):

  def __init__(self, x, y, lato):
    Rect.__init__(self, lato, lato, x, y)

  def type (self):
    return "q"
   
class Circle (Shape):
  def __init__(self, x, y, raggio):
    self.raggio = raggio
    self.x = x
    self.y = y
   
  def draw (self):
    print("Circle: centro:", self.x, "raggio", self.raggio)
    
  def setRadius(self, r):
    if r >= 0 :
      self.raggio=r
  
  def boundingRect(self):
    p0_x = self.x - self.raggio
    p0_y = self.y - self.raggio
    l = 2 * self.raggio
    
    return Rect(p0_x, p0_y, l , l)

  def type(self):
    return 'c'
 

class Piano:
  def __init__(self):
    self.shapes=[]

  def add_shape(self,shape):
    self.shapes.append(shape)

  def get_rects(self):
    rects=[]
    for s in self.shapes:
      if s.type()=='r':
        rects.append(s)

    return rects
    
  def get_circles(self):
    l=[]

    for s in self.shapes:
      if s.type()=='c':
        l.append(s)
   
    return l

       

    
